# -*- coding: utf-8 -*-
from setuphelpers import *
from waptcrypto import *
import string
import random


dict_admin = {
    "en": "administrator",
    "fr": "administrateur",
    "de": "administrator",
    "pl": "administrator",
    "es": "Administrador",
    "pt": "administrador",
    "it": "administrator",
    "nl": "administrator",
    "ru": "Администратор",
}


def install():

    # you can add you ssl certificate in the package in order to decrypt information in the audit_data
    for crt in glob.glob("*.crt"):
        filecopyto(crt, makepath(WAPT.wapt_base_dir, "ssl", crt))
    audit()


def audit():
    all_passwords = list(WAPT.read_audit_data_set("laps", "local_admin_password"))
    if all_passwords:
        last_date = list(WAPT.read_audit_data_set("laps", "local_admin_password"))[-1][2]
    else:
        last_date = None
    if not last_date or (datetime.datetime.now() - isodate2datetime(last_date) > datetime.timedelta(days=365)) or force == True:
        randompassword = password_generator(size=random.randint(10, 16), chars=string.ascii_letters + string.digits)
        run(r"net user %s /active:yes" % dict_admin[WAPT.get_host_locales()[0]])
        run(r"net user %s %s" % (dict_admin[WAPT.get_host_locales()[0]], randompassword))
        WAPT.write_audit_data_if_changed("laps", "local_admin_password", encrypted_data_str(randompassword, [WAPT.public_certs_dir]), max_count=3)
    return "OK"


def password_generator(size=16, chars=string.ascii_letters + string.digits):
    """
    Returns a string of random characters, useful in generating temporary
    passwords for automated password resets.

    size: default=8; override to provide smaller/larger passwords
    chars: default=A-Za-z0-9; override to provide more/less diversity

    Credit: Ignacio Vasquez-Abrams
    Source: http://stackoverflow.com/a/2257449
    """
    return "".join(random.choice(chars) for i in range(size))
